/* simple "mappers" */

/* --- start at $0000
	used by non-megaROM 48KB and 64KB ROMs, and some other games, eg.
	Beam Rider, Break In, Decathlon, Hero, River Raid
*/
static void mapinit_0000(int slot)
{
	int i,j;
	
	j=cartpages[slot]; if (j>8) j=8;
	for (i=0;i<j;i++) cartbank[slot][i]=i;
}



/* --- start at $4000
	used by most small ROMs, eg.
	Antarctic Adventure, Athletic Land, Coaster Race, Doki Doki Penguin Land, Eggerland Mystery,
	Goonies, Knightmare (Majyo Densetsu), Kung Fu Master (Seiken Acho), Magical Tree, Pooyan,
	Road Fighter, Thexder, Yie Ar Kung-Fu 1,2, Zanac
*/
static void mapinit_4000(int slot)
{
	int i,j;
	
	j=cartpages[slot]; if (j>6) j=6;
	for (i=0;i<j;i++) cartbank[slot][i+2]=i;
}



/* --- start at $8000
	used by Basic ROMs, some others, eg.
	Candoo Ninja, Rise Out, Roller Ball, Rotors
*/
static void mapinit_8000(int slot)
{
	int i,j;
	
	j=cartpages[slot]; if (j>4) j=4;
	for (i=0;i<j;i++) cartbank[slot][i+4]=i;
}



/* --- start at $C000 (no auto boot)
	used by: dunno :P
*/
static void mapinit_c000(int slot)
{
	int i,j;
	
	j=cartpages[slot]; if (j>2) j=2;
	for (i=0;i<j;i++) cartbank[slot][i+6]=i;
}



/* --- mirrored
	with the exception of Basic ROMs, all simple ROMs should be compatible with this
*/
static void mapinit_mirror(int slot)
{
	int i,j;
	
	switch (cartpages[slot]) {
		/* 8KB: mirrored over 8 pages */
		case 1:
			for (i=0;i<8;i++) cartbank[slot][i]=0;
			break;
		
		/* 16KB: mirrored over 4 pages */
		case 2:
			for (i=0;i<8;i++) cartbank[slot][i]=i&1;
			break;
		
		/* 24KB/32KB: start at $4000, mirror rest (never seen any 24k rom though) */
		case 3: case 4:
			cartbank[slot][2]=cartbank[slot][6]=0;
			cartbank[slot][3]=cartbank[slot][7]=1;
			cartbank[slot][4]=cartbank[slot][0]=2;
			cartbank[slot][5]=cartbank[slot][1]=2+(cartpages[slot]-3);
			break;
		
		/* >32KB: start at 0, mirror rest */
		default:
			j=cartpages[slot];
			if (j>8) j=8;
			else for (i=j;i<8;i++) cartbank[slot][i]=i-j;
			for (i=0;i<j;i++) cartbank[slot][i]=i;
			break;
	}
}
